Attribute VB_Name = "mSbCls"
Option Explicit

 Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
 Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
 Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
 
 Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
 Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
 Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
 Private Const idSbCls = "idSbCls" '   -             

Dim procSbCl() As ISbCls, hw() As Long, oldPr() As Long
Dim maxCnt As Integer ', cntWn As Integer
Dim flInic As Boolean

Public Const GWL_WNDPROC = (-4)
Public Function setSbcls(cls As ISbCls, hwnd As Long) As Long


    Dim i As Long, id As Long
    id = GetProp(hwnd, idSbCls)
    If id Then
      Exit Function
    End If
    
    For i = 1 To maxCnt
       If oldPr(i) = 0 Then Exit For '  
    Next
    If i > maxCnt Then  '    ,     
       maxCnt = i + 7
       ReDim Preserve procSbCl(1 To maxCnt)
       ReDim Preserve hw(1 To maxCnt)
       ReDim Preserve oldPr(1 To maxCnt)
    End If
    
    oldPr(i) = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WinProc)
    If oldPr(i) Then
     hw(i) = hwnd
     Set procSbCl(i) = cls
     Call SetProp(hwnd, idSbCls, i)
     setSbcls = i
    Else
    End If

End Function


Public Sub removeSbCls(hwnd As Long)
    Dim id As Long
    On Error Resume Next
    id = GetProp(hwnd, idSbCls)
    If id Then
          Call SetWindowLong(hwnd, GWL_WNDPROC, oldPr(id))
          oldPr(id) = 0 ' 
          Set procSbCl(id) = Nothing
          RemoveProp hwnd, idSbCls
    Else
'      ErrRaise 4, " !"
    End If
      
End Sub


Public Sub removeAllSubclss()
Dim i As Integer
    On Error Resume Next
    For i = 1 To maxCnt
      If oldPr(i) Then
          Call SetWindowLong(hw(i), GWL_WNDPROC, oldPr(i))
          oldPr(i) = 0 ' 
          Set procSbCl(i) = Nothing
          RemoveProp hw(i), idSbCls
      End If
    Next
    
End Sub

Private Function WinProc(ByVal hwnd As Long _
                  , ByVal uMsg As Long, ByVal wParam As Long _
                  , ByVal lParam As Long) As Long

Dim id As Long
id = GetProp(hwnd, idSbCls)

If id Then
        On Error Resume Next
            WinProc = procSbCl(id).WinProc(hwnd, uMsg, wParam, lParam, oldPr(id))
        If Err.Number Then
           WinProc = DefWindowProc(hwnd, uMsg, wParam, lParam)
        End If
Else
  WinProc = DefWindowProc(hwnd, uMsg, wParam, lParam)
End If

End Function


Public Sub HLWord(ByVal wd As Long, lW As Integer, hw As Integer)
'On Error Resume Next
  lW = wd And &H7FFF&
  If wd And &H8000& Then lW = lW Or &H8000
  hw = (wd And &HFFFF0000) \ &H10000
End Sub

Public Function LoWord(lDWord As Long) As Integer
  If lDWord And &H8000& Then ' ,      
    LoWord = lDWord Or &HFFFF0000
  Else
    LoWord = lDWord And &HFFFF&
  End If
End Function

Public Function MakeDWord(LoWord As Integer, HiWord As Integer) As Long
    MakeDWord = (HiWord * &H10000) Or (LoWord And &HFFFF&)
End Function

Public Function HIBYTE(ByVal Wrd As Integer) As Byte
  If Wrd And &H8000 Then
    HIBYTE = (Wrd And &H7F00) / &H100 Or &H80
  Else
    HIBYTE = Wrd / &H100
  End If
End Function

Public Function LOBYTE(ByVal Wrd As Integer) As Byte
  LOBYTE = Wrd And &HFF
End Function



